#include "systemc.h"

#include <iostream>

class Module: sc_module {

public:
  void thread1()
  {
    event_to_thread_2.notify(SC_ZERO_TIME);
  }

  void thread2()
  {
    wait(event_to_thread_2);
    event_to_thread_3.notify(SC_ZERO_TIME);
  }

  void thread3()
  {
    wait(event_to_thread_3);
  }


  void thread4()
  {
    event_to_thread_5.notify(SC_ZERO_TIME);

    wait(event_to_thread_4);
    //std::cout << "END" << std::endl;
  }

  void thread5()
  {

    wait(event_to_thread_5);
    event_to_thread_6.notify(SC_ZERO_TIME);

    wait(event_to_thread_5);
    event_to_thread_4.notify(SC_ZERO_TIME);
  }

  void thread6()
  {
    wait(event_to_thread_6);

    event_to_thread_5.notify(SC_ZERO_TIME);
  }


  void thread7()
  {
    event_to_thread_8.notify(SC_ZERO_TIME);
    wait(event_to_thread_7);

    // loop
    event_to_thread_8.notify(SC_ZERO_TIME);
    wait(event_to_thread_7);
    //std::cout << "END1" << std::endl;
  }

  void thread8()
  {
    wait(event_to_thread_8);
    event_to_thread_9.notify(SC_ZERO_TIME);

    wait(event_to_thread_8);
    event_to_thread_7.notify(SC_ZERO_TIME);


    //loop
    wait(event_to_thread_8);
    event_to_thread_9.notify(SC_ZERO_TIME);

    wait(event_to_thread_8);
    event_to_thread_7.notify(SC_ZERO_TIME);
  }

  void thread9()
  {
    wait(event_to_thread_9);

    event_to_thread_8.notify(SC_ZERO_TIME);

    // loop
    wait(event_to_thread_9);

    event_to_thread_8.notify(SC_ZERO_TIME);
  }



  SC_HAS_PROCESS(Module);

  sc_event event_to_thread_2;
  sc_event event_to_thread_3;

  sc_event event_to_thread_4;
  sc_event event_to_thread_5;
  sc_event event_to_thread_6;

  sc_event event_to_thread_7;
  sc_event event_to_thread_8;
  sc_event event_to_thread_9;

  Module(sc_module_name mn): sc_module(mn) {

    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);

    SC_THREAD(thread4);
    SC_THREAD(thread5);
    SC_THREAD(thread6);

    SC_THREAD(thread7);
    SC_THREAD(thread8);
    SC_THREAD(thread9);
  }
};


int sc_main(int argc, char **argv)
{
  Module m("m");
  sc_start();
  return 0;
}

