#include "systemc_definitions.h"

namespace risc {

namespace tools {

SgClassDefinition *SystemCDefinitions::sc_module_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_port_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_port_base_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_in_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_out_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_inout_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_event_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_event_and_list_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_event_or_list_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_prim_channel_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_interface_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_fifo_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_fifo_in_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_fifo_out_ = NULL;

SgClassDefinition *SystemCDefinitions::sc_channel_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_in_clk_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_out_clk_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_inout_clk_ = NULL;

SgFunctionDefinition *SystemCDefinitions::sc_main_ = NULL;

std::vector<SgNamespaceDefinitionStatement*> SystemCDefinitions::sc_core_;
std::vector<SgNamespaceDefinitionStatement*> SystemCDefinitions::sc_dt_;

std::set<SgFunctionDefinition*> SystemCDefinitions::sc_wait_funcs_;

bool SystemCDefinitions::is_initialized_ = false;

}; // end of namespace tools

}; // end of namespace risc


/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
