#include "systemc.h"

class MyModule: public sc_module {
public:
  sc_in_clk clk_in;
  int x, y;

  enum Color {White, Black};

  SC_HAS_PROCESS(MyModule);

  MyModule(sc_module_name mn): sc_module(mn)
  {
    SC_CTHREAD(my_cthread1, clk_in);
  }

  void my_cthread1()
  {
    /* some initialization */
    if(White) {
      x = 42;
    }

    if(Black) {
      y = 43;
    }

    // First wait statement
    wait();

    /* computation and communication */

    if(White) {
      int l = x;
    }

    if(Black) {
      int l = y;
    }

    /* computation and communication */
  }

};


int sc_main(int argc, char **argv)
{
  MyModule mm("mm");
//  sc_signal<bool> signal;
//  mm.clk_in.bind(signal);

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
