#include "systemc.h"

class FireWire: public sc_module {

public:

  SC_HAS_PROCESS(FireWire);

  sc_event event1;
  sc_event event2;
  sc_event event3;
  sc_event event4;
  sc_event event5;
  sc_event event6;
  sc_event event7;
  sc_event event8;
  sc_event event9;
  sc_event event10;
  sc_event event11;
  sc_event event12;
  sc_event event13;
  sc_event event14;
  sc_event event15;
  sc_event event16;
  sc_event event17;
  sc_event event18;
  sc_event event19;
  sc_event event20;
  sc_event event21;
  sc_event event22;
  sc_event event23;
  sc_event event24;
  sc_event event25;
  sc_event event26;
  sc_event event27;
  sc_event event28;

  void thread1()
  {
    wait(event1);
    wait(event2); // Valid ACK
    event3.notify(SC_ZERO_TIME);
    wait(event6);
    wait(event7);
    /********************* 1 - 7 *********************/

    wait(event9);
    wait(event12);
    /********************* 8 - 12 *********************/

    event13.notify(SC_ZERO_TIME);
    wait(event15);
    wait(event16);
    /********************* 13 - 17 *********************/

    event18.notify(SC_ZERO_TIME);
    wait(event21);
    wait(event22);
    /********************* 18 - 22 *********************/

    wait(event27);
    event28.notify(SC_ZERO_TIME);
  }

  void thread2()
  {
    wait(event3);
    event4.notify(SC_ZERO_TIME);
    event6.notify(SC_ZERO_TIME);
    /********************* 1 - 7 *********************/

    event8.notify(SC_ZERO_TIME);
    event9.notify(SC_ZERO_TIME);
    wait(event10);
    /********************* 8 - 12 *********************/

    wait(event13);
    event14.notify(SC_ZERO_TIME);
    event15.notify(SC_ZERO_TIME);
    event16.notify(SC_ZERO_TIME);
    event17.notify(SC_ZERO_TIME);
    /********************* 13 - 17 *********************/

    wait(event18);
    event20.notify(SC_ZERO_TIME);
    event21.notify(SC_ZERO_TIME);
    /********************* 18 - 22 *********************/

    wait(event24);
    event26.notify(SC_ZERO_TIME);

  }

  void thread3()
  {
    wait(event4);
    event5.notify(SC_ZERO_TIME);
    event7.notify(SC_ZERO_TIME);
    /********************* 1 - 7 *********************/

    wait(event8);
    event10.notify(SC_ZERO_TIME);
    wait(event11);
    event12.notify(SC_ZERO_TIME);
    /********************* 8 - 12 *********************/

    /********************* 13 - 17 *********************/

    event19.notify(SC_ZERO_TIME);
    wait(event20);
    /********************* 18 - 22 *********************/

    wait(event23);
    event24.notify(SC_ZERO_TIME);
    event25.notify(SC_ZERO_TIME);
  }

  void thread4()
  {
    event1.notify(SC_ZERO_TIME);
    event2.notify(SC_ZERO_TIME);
    wait(event5);
    /********************* 1 - 7 *********************/

    event11.notify(SC_ZERO_TIME);
    /********************* 8 - 12 *********************/

    wait(event14);
    wait(event17);
    /********************* 13 - 17 *********************/

    wait(event19);
    event22.notify(SC_ZERO_TIME);
    /********************* 18 - 22 *********************/

    event23.notify(SC_ZERO_TIME);
    wait(event25);
    wait(event26);
    event27.notify(SC_ZERO_TIME);
    wait(event28);
  }

  FireWire(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
    SC_THREAD(thread4);
  }
};


int sc_main(int argc, char **argv)
{
  FireWire fw("firewire");
  return 0;
}

