#include "method.h"

#include "event.h"
#include "port.h"

risc::Method::Method(SgFunctionDefinition *ast_node):
  Function(ast_node, MethodType)
{ }

void risc::Method::print_event_list()
{
  for(int i=0; i < static_event_sensitivity_list_.size(); i++) {

    std::cout << static_event_sensitivity_list_.at(i)->get_name();

    // true if it is not the last element
    if(i != static_event_sensitivity_list_.size()-1) {

      std::cout << ", ";
    }
  }

  if(static_event_sensitivity_list_.size() != 0){
      std::cout << ", ";
  }

  for(int i=0; i < static_port_sensitivity_list_.size(); i++) {

    std::cout << static_port_sensitivity_list_.at(i)->get_name();

    // true if it is not the last element
    if(i != static_port_sensitivity_list_.size()-1) {

      std::cout << ", ";
    }
  }
  std::cout << std::endl;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
