#include "module_instance.h"

risc::ModuleInstance::ModuleInstance(
    SgVariableDefinition *ast_node,
    Module *ir_def):
  Instance(ast_node, ModuleInstanceType),
  module_definition_(ir_def)
{
  if(ir_def == NULL) {
    assert(0);
  }
}

risc::ModuleInstance::ModuleInstance(
    SgVariableDefinition *ast_node,
    Type type):
  Instance(ast_node, type),
  module_definition_(NULL)
{ }

risc::Module* risc::ModuleInstance::get_definition()
{
  return module_definition_;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
