#include "systemc.h"
#include <typeinfo>
#include <cxxabi.h>

SC_MODULE(Testbench)
{
  sc_fifo<int> fi;
  sc_fifo<int> fifo[3];

  SC_CTOR(Testbench)
  { }
};

int sc_main(int argc, char**argv)
{
  Testbench tb("tb");
  std::cout << typeid(tb.fi).name() << std::endl;

  char *realname = abi::__cxa_demangle(typeid(tb.fi).name(), 0, 0, 0);
  std::cout << "Name: " << realname << std::endl;

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
