#include "systemc.h"

class CfgSwitch: public sc_module {
public:
//  int x, y, z;
//  sc_event e;
  bool test, test1;

  SC_HAS_PROCESS(CfgSwitch);

  void cfg_switch_1()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
      }
      case 2:
      {
        int b2;
      }
    }
    int c;
  }

  void cfg_switch_2()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
      }
      case 2:
      {
        int b2;
      }
      default:
      {
        int b3;
      }
    }
    int c;
  }

  void cfg_switch_3()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
        break;
      }
      case 2:
      {
        int b2;
        break;
      }
    }
    int c;
  }

  void cfg_switch_4()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
        break;
      }
      case 2:
      {
        int b2;
        break;
      }
      default:
      {
        int b3;
      }
    }
    int c;
  }

  void cfg_switch_5()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
      }
      case 2:
      {
        int b2;
      }
      case 3:
      {
        int b3;
        break;
      }
      case 4:
      {
        int b4;
      }
      case 5:
      {
        int b5;
        break;
      }
      case 6:
      {
        int b6;
      }
      default:
      {
        int b7;
      }
    }
    int c;
  }

  void cfg_switch_6()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
        if(a){
          int bb1;
        } else {
          int bb2;
        }
        int bb3;
      }
      case 2:
      {
        int b2;
      }
      default:
      {
        int b3;
      }
    }
    int c;
  }

  void cfg_switch_7()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
        if(a){
          int bb1;
        } else {
          int bb2;
        }

        int bb3;

        if(a){
          int bb5;
        } else {
          int bb6;
        }
        int bb7;
      }
      case 2:
      {
        int b2;
      }
      default:
      {
        int b3;
      }
    }
    int c;
  }

  void cfg_switch_8()
  {
    int a;
    switch(a) {
      case 1:
      {
        int b1;
        if(a){
          break;
        } else {
          int bb2;
        }

        int bb3;

        if(a){
          int bb5;
        } else {
          break;
        }
        int bb7;
      }
      case 2:
      {
        int b2;
      }
      default:
      {
        int b3;
      }
    }
    int c;
  }

  CfgSwitch(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(cfg_switch_1);
    SC_THREAD(cfg_switch_2);
    SC_THREAD(cfg_switch_3);
    SC_THREAD(cfg_switch_4);
    SC_THREAD(cfg_switch_5);
    SC_THREAD(cfg_switch_6);
    SC_THREAD(cfg_switch_7);
    SC_THREAD(cfg_switch_8);
  }
};


#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  CfgSwitch mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
